import { SetMetadata } from '@nestjs/common';
import { UNPROTECTED_URL } from '../../constants';

/**
 * This decorator will exclude the request from token check
 *
 * NOTE:
 * Because the request does'nt provide token,
 * the side effect are, function can't access `UserProvider`
 * or `UserProvider` will return null
 */
export const Unprotected = (isUnprotected = true) =>
  SetMetadata(UNPROTECTED_URL, isUnprotected);
