import { BaseReadManager } from "../base-read.manager";

export abstract class BaseDetailManager<Entity> extends BaseReadManager {

    protected dataId: string;
    protected result: Entity;

    abstract get selectData(): string[];
    abstract get relationData(): string[];
    abstract get setFindProperties(): any;

    setData(dataId: string): void {
        this.dataId = dataId;
    }

    async process(): Promise<void> {
        this.queryBuilder.select(this.selectData).where(this.setFindProperties);
        this.result = await this.queryBuilder.getOne();
    }

    getResult(): Entity {
        return this.result;
    }
}